# Javascript DLC ⚡ 👁️

[![Publish to NPM](https://github.com/AreaLayer/javascript-dlc/actions/workflows/npm-publish.yml/badge.svg)](https://github.com/AreaLayer/javascript-dlc/actions/workflows/npm-publish.yml)
[![NPM version](https://img.shields.io/npm/v/javascript-dlc.svg)](https://npmjs.org/package/javascript-dlc)
[![Bitcoin-only](https://img.shields.io/badge/bitcoin-only-FF9900?logo=bitcoin)](https://twentyone.world)
[![LN](https://img.shields.io/badge/lightning-792EE5?logo=lightning)](https://mempool.space/lightning)
[![Nostr](https://img.shields.io/badge/nostr-only-FF9900?)]((https://user-images.githubusercontent.com/99301796/223592277-34058d0e-af30-411d-8dfe-87c42dacdcf2.png))


>A Javascript library for working with [Discreet Log Contracts](https://adiabat.github.io/dlc.pdf).

**Contributions are welcome**

⚠️**Pre Sakamamoto Version**

⚠️**Use small amount**

### Standard Compliance and library

### Bitcoin 

- Bitcoin Core and other libraries

### Lightning Network:

- LND
- LDK
- Greenlight
- Eclair
- Core Lightning
- Breez SDK
- BOLT11/BOLT12

### DLCs with core functions:

- Data
- Covenants (experimental)
- EDCDSA
- Event
- Exc
- Lightning Channel (non-taproot)
- Miniscript
- Sign
- Schorr
- Sign
- Oracle
- Transaction
- Taproot Channel
- UTXOracle 

### Nostr:

- Relay and Events (experimental)

### Privacy

- Tor
- I2P

### Bitcoin Network (by default)

- Mainnet
- Testnet4
- Signet
- Regtest

## Status

The implementation is mainly based on the [DLC specifications](https://github.com/discreetlogcontracts/dlcspecs)

More information around [DLCs](https://www.dlc.wiki/)

## Run Javascript DLC

**Disclaimer:** Note this library isn't fully tested. Use your own at risk

[Documentation](https://github.com/AreaLayer/javascript-dlc/blob/main/docs/run.md)

## Library

Import packages or modules for build your own application

- [Check details](https://github.com/AreaLayer/javascript-dlc/blob/main/docs/library.md)
- [Development](https://github.com/AreaLayer/javascript-dlc/blob/main/docs/development.md)
- [Bindings](https://github.com/AreaLayer/javascript-dlc/blob/main/docs/bindings.md)

## Contribution

[Checkout here](https://github.com/AreaLayer/javascript-dlc/blob/main/CONTRIBUTING.md)

## Roadmap

- [ ] Nakamoto version in 2025
- [x] Ark compatible (Basic)
- [x] Ark Wallet SDK (WIP)
- [ ] BTC signer
  
## Contributors

<a align="center" href="https://github.com/AreaLayer/javascript-dlc/graphs/contributors">
  <img src="https://contrib.rocks/image?repo=AreaLayer/javascript-dlc" />
</a>
